# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import pulumi
import pulumi.runtime

class Member(pulumi.CustomResource):
    """
    Provides a resource to manage a GuardDuty member.
    
    ~> **NOTE:** Currently after using this resource, you must manually invite and accept member account invitations before GuardDuty will begin sending cross-account events. More information for how to accomplish this via the AWS Console or API can be found in the [GuardDuty User Guide](https://docs.aws.amazon.com/guardduty/latest/ug/guardduty_accounts.html). Terraform implementation of member invitation and acceptance resources can be tracked in [Github](https://github.com/terraform-providers/terraform-provider-aws/issues/2489).
    """
    def __init__(__self__, __name__, __opts__=None, account_id=None, detector_id=None, email=None):
        """Create a Member resource with the given unique name, props, and options."""
        if not __name__:
            raise TypeError('Missing resource name argument (for URN creation)')
        if not isinstance(__name__, basestring):
            raise TypeError('Expected resource name to be a string')
        if __opts__ and not isinstance(__opts__, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')

        __props__ = dict()

        if not account_id:
            raise TypeError('Missing required property account_id')
        elif not isinstance(account_id, basestring):
            raise TypeError('Expected property account_id to be a basestring')
        __self__.account_id = account_id
        """
        AWS account ID for member account.
        """
        __props__['accountId'] = account_id

        if not detector_id:
            raise TypeError('Missing required property detector_id')
        elif not isinstance(detector_id, basestring):
            raise TypeError('Expected property detector_id to be a basestring')
        __self__.detector_id = detector_id
        """
        The detector ID of the GuardDuty account where you want to create member accounts.
        """
        __props__['detectorId'] = detector_id

        if not email:
            raise TypeError('Missing required property email')
        elif not isinstance(email, basestring):
            raise TypeError('Expected property email to be a basestring')
        __self__.email = email
        """
        Email address for member account.
        """
        __props__['email'] = email

        super(Member, __self__).__init__(
            'aws:glacier/member:Member',
            __name__,
            __props__,
            __opts__)

    def set_outputs(self, outs):
        if 'accountId' in outs:
            self.account_id = outs['accountId']
        if 'detectorId' in outs:
            self.detector_id = outs['detectorId']
        if 'email' in outs:
            self.email = outs['email']
